Bug 443655 - Clean up handling of short readdir packets in NFS client
Clean up handling of short readdir packets in NFS client
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
4.8
All Linux
high Severity medium
: rc
: ---
Assigned To: Jeff Layton
Martin Jenner
http://rhts.lab.boston.redhat.com/cgi...
:
Depends On: 428720
Blocks: RHEL4u8_relnotes 461297
  Show dependency treegraph
 
Reported: 2008-04-22 14:24 EDT by Jeff Layton
Modified: 2009-05-18 15:19 EDT (History)
9 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Previously, the NFS (Network File System) client was not handling malformed replies from the readdir() function. Consequently, the reply from the server would indicate that the call to the readdir() function was successful, but the reply would contain no entries. With this update, the readdir() reply parsing logic has been changed, such that when a malformed reply is received, the client returns an EIO error.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-05-18 15:19:22 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
clean up short packet handling for NFSv2 readdir (2.79 KB, patch)
2008-04-22 14:30 EDT, Jeff Layton
no flags Details | Diff
clean up short packet handling for NFSv3 readdir (2.85 KB, patch)
2008-04-22 14:30 EDT, Jeff Layton
no flags Details | Diff
clean up short packet handling for NFSv4 readdir (3.03 KB, patch)
2008-04-22 14:31 EDT, Jeff Layton
no flags Details | Diff

  None (edit)
Comment 1 Jeff Layton 2008-04-22 14:30:21 EDT
Created attachment 303354 [details]
clean up short packet handling for NFSv2 readdir
Comment 2 Jeff Layton 2008-04-22 14:30:43 EDT
Created attachment 303355 [details]
clean up short packet handling for NFSv3 readdir
Comment 3 Jeff Layton 2008-04-22 14:31:03 EDT
Created attachment 303356 [details]
clean up short packet handling for NFSv4 readdir
Comment 4 Jeff Layton 2008-04-22 14:32:19 EDT
This is a backport of the patchset sent upstream and currently in Bruce Fields'
git tree. The upstream set should be on track for 2.6.26.
Comment 6 RHEL Product and Program Management 2008-04-25 10:02:32 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 8 RHEL Product and Program Management 2008-09-03 09:05:35 EDT
Updating PM score.
Comment 9 Vivek Goyal 2008-09-25 09:18:22 EDT
Committed in 78.11.EL . RPMS are available at http://people.redhat.com/vgoyal/rhel4/
Comment 12 Jeff Layton 2009-01-28 07:25:10 EST
Release note added. If any revisions are required, please set the 
"requires_release_notes" flag to "?" and edit the "Release Notes" field accordingly.
All revisions will be proofread by the Engineering Content Services team.

New Contents:
Cause: the NFS client didn't handle malformed READDIR replies properly.

Consequence: If a READDIR reply was truncated at the proper spot (usually due to a buggy server), then it would return success to the caller but no entries.

Fix: A patch was submitted upstream to refactor the READDIR reply parsing logic and backported to RHEL4

Result: When one of these malformed replies is received, the client now returns an EIO error to the caller
Comment 15 Ryan Lerch 2009-02-23 21:21:30 EST
Release note updated. If any revisions are required, please set the 
"requires_release_notes"  flag to "?" and edit the "Release Notes" field accordingly.
All revisions will be proofread by the Engineering Content Services team.

Diffed Contents:
@@ -1,7 +1 @@
-Cause: the NFS client didn't handle malformed READDIR replies properly.
+Previously, the NFS (Network File System) client was not handling malformed replies from the readdir() function. Consequently, the reply from the server would indicate that the call to the readdir() function was successful, but the reply would contain no entries. With this update, the readdir() reply parsing logic has been changed, such that when a malformed reply is received, the client returns an EIO error.-
-Consequence: If a READDIR reply was truncated at the proper spot (usually due to a buggy server), then it would return success to the caller but no entries.
-
-Fix: A patch was submitted upstream to refactor the READDIR reply parsing logic and backported to RHEL4
-
-Result: When one of these malformed replies is received, the client now returns an EIO error to the caller
Comment 18 errata-xmlrpc 2009-05-18 15:19:22 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-1024.html

Note You need to log in before you can comment on or make changes to this bug.